'use strict';
import { Component, Input } from '@angular/core';
import { tmpl } from './templates/df.links.pug';
var DFLinksComponent = /** @class */ (function () {
    function DFLinksComponent() {
        this.getQP = function (queryParams, item) {
            /* here we get from the json config the query Params
                    * it will be appended to the url as in ?inac=xxxx&country=yyyy
                    */
            var qp = {};
            if (queryParams) {
                for (var _i = 0, queryParams_1 = queryParams; _i < queryParams_1.length; _i++) {
                    var param = queryParams_1[_i];
                    qp[param] = item[param];
                }
            }
            return qp;
        };
        this.getRL = function (routerLink, item) {
            /* here we get from the json config the links part
                    * it contains the link
                    * and it might contain the id or param as in customer/:id
                    */
            var rl = [];
            if (routerLink.link) {
                rl.push(routerLink.link);
            }
            if (routerLink.param) {
                rl.push(item[routerLink.param] || routerLink.param);
            }
            if (routerLink.params) {
                routerLink.params.forEach(function (param) {
                    rl.push(item[param] || param);
                });
            }
            return rl;
        };
    }
    DFLinksComponent.decorators = [
        { type: Component, args: [{
                    selector: 'df-links',
                    template: tmpl,
                },] },
    ];
    /** @nocollapse */
    DFLinksComponent.ctorParameters = function () { return []; };
    DFLinksComponent.propDecorators = {
        "links": [{ type: Input },],
        "item": [{ type: Input },],
    };
    return DFLinksComponent;
}());
export { DFLinksComponent };
