'use strict';
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { Component, Input, KeyValueDiffers } from '@angular/core';
import { DFQuestionControlService } from '../services/df.question.control.service';
import { FormGroup } from '@angular/forms';
import { tmpl } from './templates/df.read.pug';
import { DFCommonService } from '../services/df.common.api';
import { default as isDate } from 'lodash-es/isDate';
import { default as isObject } from 'lodash-es/isObject';
import { default as isArray } from 'lodash-es/isArray';
import { default as each } from 'lodash-es/each';
import { DFStoreFunctions } from '../services/store/df.store.functions';
var DFReadComponent = /** @class */ (function () {
    function DFReadComponent(DFCS, differs, qcs, DSF) {
        var _this = this;
        this.DFCS = DFCS;
        this.differs = differs;
        this.qcs = qcs;
        this.DSF = DSF;
        this.dependents = [];
        this.depsToWatch = [];
        this.fieldsToWatch = [];
        this.setValue = function (val) {
            if (val === undefined) {
                _this.value = '';
            }
            else if (isObject(val) && !isDate(val) && !isArray(val)) {
                if (val[_this.question.key] !== undefined) {
                    _this.value = val[_this.question.key];
                }
            }
            else {
                _this.value = _this.question.controlType === 'spinner'
                    ? Number(val).toFixed(_this.question.decimals)
                    : val;
            }
        };
        this.onAction = function (values) {
            /* tslint:disable:no-parameter-reassignment */
            values = _this.question.actions.required
                ? _this.DSF.OA(_this.filter(_this.form.value, _this.question.actions.required), values)
                : _this.DSF.OA(_this.form.value, values);
            _this.DFCS.formChanged({
                action: _this.question.actions.action,
                params: _this.question.actions.params,
                values: _this.question.actions.values
                    ? __assign({}, _this.question.actions.values, values) : __assign({}, values),
            });
        };
        this.evalStr = function (str) {
            return eval(str);
        };
        this.filter = function (records, required) {
            var values = {};
            each(required, function (f) {
                values[f.in] = records[f.out];
            });
            return values;
        };
    }
    Object.defineProperty(DFReadComponent.prototype, "isVisible", {
        get: function () {
            var x = true;
            if (this.question.hideMode && this.question.hideMode === 'read') {
                x = false;
            }
            if (this.question.hidden) {
                x = false;
            }
            return x;
        },
        enumerable: true,
        configurable: true
    });
    DFReadComponent.prototype.ngOnInit = function () {
        this.differ = this.differs.find(this.form).create();
    };
    DFReadComponent.prototype.ngDoCheck = function () {
        var changes = this.differ.diff(this.question);
        if (changes) {
            if (this.question.dependency) {
                this.checkDependency();
            }
        }
    };
    DFReadComponent.prototype.checkDependency = function () {
        var _this = this;
        this.depsToWatch = this.qcs.getDependents(this.question, this.fieldsToWatch, this.dependents, this.formQuestions);
        this.dependents.forEach(function (dep) {
            switch (dep.type) {
                case 'hide-when':
                    var status_1 = _this.evalStr(dep.condition);
                    _this.question.hidden = status_1;
                    if (status_1) {
                        _this.question.value = undefined;
                        var q = _this.form.get(_this.question.key);
                        if (q) {
                            q.setValue(undefined);
                        }
                    }
                    break;
                case 'show-when':
                    _this.question.hidden = !_this.evalStr(dep.condition);
                    break;
                default:
                    break;
            }
        });
    };
    DFReadComponent.decorators = [
        { type: Component, args: [{
                    selector: 'df-read',
                    template: tmpl,
                },] },
    ];
    /** @nocollapse */
    DFReadComponent.ctorParameters = function () { return [
        { type: DFCommonService, },
        { type: KeyValueDiffers, },
        { type: DFQuestionControlService, },
        { type: DFStoreFunctions, },
    ]; };
    DFReadComponent.propDecorators = {
        "question": [{ type: Input },],
        "formStyle": [{ type: Input },],
        "form": [{ type: Input },],
        "formQuestions": [{ type: Input },],
    };
    return DFReadComponent;
}());
export { DFReadComponent };
