'use strict';
var QuestionBase = /** @class */ (function () {
    function QuestionBase(options) {
        if (options === void 0) { options = {}; }
        this.actions = options.actions;
        this.class = options.class;
        this.controlType = options.controlType || '';
        this.dependency = options.dependency;
        this.disabled = !!options.disabled;
        this.displayField = options.displayField;
        this.displayName = options.displayName || options.displayField;
        this.hidden = !!options.hidden;
        if (options.key) {
            this.key = options.key;
        }
        this.label = options.label;
        this.max = options.max;
        this.maxLength = options.maxLength;
        this.minLength = options.minLength;
        this.minLengthVal = true;
        this.order = options.order === undefined ? 1 : options.order;
        this.required = !!options.required;
        this.readOnly = options.readOnly === undefined
            ? undefined
            : options.readOnly;
        this.hideMode = options.hideMode;
        this.showBpImg = !!options.showBpImg;
        this.style = options.style;
        this.subClass = options.subClass || '';
        this.typeClass = options.typeClass;
        this.typeStyle = options.typeStyle;
        this.text = options.text;
        this.value = options.value;
        this.size = options.size;
        this.fromEnv = options.fromEnv;
    }
    QuestionBase.prototype.getProperty = function (property) {
        switch (property) {
            case 'key': return this.key;
            case 'label': return this.label;
            case 'required': return this.required;
            case 'order': return this.order;
            case 'controlType': return this.controlType;
            case 'disabled': return this.disabled;
            case 'minLength': return this.minLength;
            case 'maxLength': return this.maxLength;
            case 'max': return this.max;
            case 'dependency': return this.dependency;
            case 'hidden': return this.hidden;
            case 'readOnly': return this.readOnly;
            case 'showBpImg': return this.showBpImg;
            case 'displayField': return this.displayField;
            case 'fromEnv': return this.fromEnv;
            case 'default': return '';
            default: return '';
        }
    };
    return QuestionBase;
}());
export { QuestionBase };
