'use strict';
import { default as cloneDeep } from 'lodash-es/cloneDeep';
var ADD_DATA = 'ADD_DATA';
var ADD_FORM_DATA = 'ADD_FORM_DATA';
var ADD_STORE = 'ADD_STORE';
var RESET_STORE = 'RESET_STORE';
var RESET_FORM_STORE = 'RESET_FORM_STORE';
var ADD_STORE_ITEM_RCD = 'ADD_STORE_ITEM_RCD';
var ADD_STORE_RCD = 'ADD_STORE_RCD';
var REM_STORE = 'REM_STORE';
var REM_STORE_ITEM_RCD = 'REM_STORE_ITEM_RCD';
var REM_STORE_RCD = 'REM_STORE_RCD';
var UPD_STORE = 'UPD_STORE';
var UPD_STORE_ITEM_RCD = 'UPD_STORE_ITEM_RCD';
var UPD_STORE_RCD = 'UPD_STORE_RCD';
var UPD_STORE_FORM_RCD = 'UPD_STORE_FORM_RCD';
var initialState = {
    empty: undefined,
    error: false,
    loaded: false,
    query: { rows: 50, first: 0 },
    records: [],
    store: undefined,
    totalRecords: 0,
};
var initState = {
    error: false,
    states: {},
};
/* tslint:disable:only-arrow-functions */
export function StoreReducer(state, action) {
    if (state === void 0) { state = initState; }
    var results = action.payload;
    var idx;
    switch (action.type) {
        case ADD_DATA:
            var x = {
                empty: results.empty,
                error: results.error,
                loaded: results.loaded,
                query: results.query,
                records: results.records,
                store: results.store,
                totalRecords: results.totalRecords,
            };
            return Object.assign(state, { states: Object.assign({}, state.states, (_a = {}, _a[results.store] = x, _a)) });
        case ADD_FORM_DATA:
            var ft = cloneDeep(state.states[results.store]);
            var y1 = void 0;
            if (ft !== undefined) {
                y1 = {
                    error: results.error,
                    form: Object.assign(ft.form, results.form),
                    loaded: true,
                    // if it's loaded , don't load again !!
                    store: results.store,
                    target: Object.assign(ft.target, results.target),
                    values: Object.assign(ft.values, results.values),
                };
            }
            else {
                y1 = {
                    error: results.error,
                    form: results.form,
                    loaded: results.loaded,
                    store: results.store,
                    target: results.target,
                    values: results.values,
                };
            }
            return Object.assign(state, { states: Object.assign({}, state.states, (_b = {}, _b[results.store] = y1, _b)) });
        case ADD_STORE:
            var st = results.query !== undefined
                ? Object.assign({}, cloneDeep(initialState), { query: results.query })
                : cloneDeep(initialState);
            if (state.states && state.states[results.store]) {
                return state;
            }
            return Object.assign(state, { states: Object.assign({}, state.states, (_c = {}, _c[results.store] = st, _c)) });
        case RESET_STORE:
            return Object.assign(state, { states: Object.assign({}, state.states, (_d = {}, _d[results.store] = cloneDeep(initialState), _d)) });
        case RESET_FORM_STORE:
            var y2 = {
                error: false,
                form: { name: '', valid: false },
                loaded: results.loaded,
                store: results.store,
                target: [],
                values: {},
            };
            return Object.assign(state, { states: Object.assign({}, state.states, (_e = {}, _e[results.store] = y2, _e)) });
        case REM_STORE:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            var s = cloneDeep(state.states);
            delete (s[results.store]);
            return Object.assign(state, { states: s });
        case UPD_STORE:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            return Object.assign(state, {
                states: Object.assign({}, state.states, (_f = {}, _f[results.store] = results.values, _f)),
            });
        case UPD_STORE_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            idx = state.states[results.store].records.findIndex(function (x1) { return x1[results.key] === results.values[results.key]; });
            if (idx > -1) {
                var t1 = cloneDeep(state.states[results.store]);
                Object.assign(t1.records[idx], results.values);
                return Object.assign(state, {
                    states: Object.assign({}, state.states, (_g = {}, _g[results.store] = t1, _g)),
                });
            }
            else {
                return state;
            }
        case UPD_STORE_FORM_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            var ft1 = cloneDeep(state.states[results.store]);
            y1 = {
                error: results.error,
                form: ft1.form,
                loaded: results.loaded,
                store: results.store,
                target: ft1.target,
                values: Object.assign(ft1.values, results.values),
            };
            return Object.assign(state, { states: Object.assign({}, state.states, (_h = {}, _h[results.store] = y1, _h)) });
        case REM_STORE_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            idx = state.states[results.store].records.findIndex(function (x1) { return x1[results.key] === results.values[results.key]; });
            if (idx > -1) {
                var t0 = cloneDeep(state.states[results.store]);
                t0.records.splice([idx], 1);
                t0.totalRecords = t0.records.length;
                return Object.assign(state, { states: Object.assign({}, state.states, (_j = {}, _j[results.store] = t0, _j)) });
            }
            else {
                return state;
            }
        case ADD_STORE_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            var t = cloneDeep(state.states[results.store]);
            if (results.unshift) {
                t.records.unshift(results.values);
            }
            else {
                t.records.push(results.values);
            }
            t.totalRecords = t.records.length;
            return Object.assign(state, { states: Object.assign({}, state.states, (_k = {}, _k[results.store] = t, _k)) });
        case UPD_STORE_ITEM_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            idx = state.states[results.store].records.findIndex(function (x1) { return x1[results.key] === results.values[results.key]; });
            if (idx > -1) {
                var record = state.states[results.store].records[idx][results.values.type];
                if (record !== undefined) {
                    var ridx = void 0;
                    if (results.index !== undefined) {
                        ridx = results.index;
                    }
                    else {
                        ridx = record.findIndex(function (x1) {
                            return x1[results.values.type] === results.values[results.values.type];
                        });
                    }
                    if (ridx > -1) {
                        Object.assign(state.states[results.store].records[idx][results.values.type][ridx], results.values);
                    }
                }
            }
            return state;
        case REM_STORE_ITEM_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            idx = state.states[results.store].records.findIndex(function (x1) {
                return x1[results.key] === results.values[results.key];
            });
            if (idx > -1) {
                var record = state.states[results.store].records[idx][results.values.type];
                if (record !== undefined) {
                    var ridx = void 0;
                    if (results.index !== undefined) {
                        ridx = results.index;
                    }
                    else {
                        ridx = record.findIndex(function (x1) {
                            return x1[results.values.type] === results.values[results.values.type];
                        });
                    }
                    if (ridx > -1) {
                        state.states[results.store].records[idx][results.values.type].splice(ridx, 1);
                    }
                }
            }
            return state;
        case ADD_STORE_ITEM_RCD:
            if (state.states && !state.states[results.store]) {
                return state;
            }
            idx = state.states[results.store].records.findIndex(function (x1) { return x1[results.key] === results.values[results.key]; });
            if (idx > -1) {
                var record = state.states[results.store].records[idx][results.values.type];
                if (record === undefined) {
                    state.states[results.store].records[idx][results.values.type] = [];
                }
                state.states[results.store].records[idx][results.values.type].push(results.values);
            }
            return state;
        default:
            return state;
    }
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
}
export var OA = function (A, B) {
    return Object.assign({}, A, B);
};
