'use strict';
import { CommonModule } from '@angular/common';
import { DFBpImgComponent } from './construct/components/df.bpImg.component';
import { DFButtonsComponent } from './construct/components/df.buttons.component';
import { DFCommonService } from './construct/services/df.common.api';
import { DFComponent } from './construct/components/df.form.component';
import { DFFieldsetGroupComponent } from './construct/components/df.fieldset.group.component';
import { DFFilterService } from './construct/services/store/df.filter.service';
import { DFFormService } from './construct/services/df.form.service';
import { DFGroupBodyComponent } from './construct/components/df.group.body.component';
import { DFGroupComponent } from './construct/components/df.group.component';
import { DFLinksComponent } from './construct/components/df.links.component';
import { DFListComponent } from './construct/components/df.list.component';
import { DFQuestionComponent } from './construct/components/df.question.component';
import { DFReadComponent } from './construct/components/df.read.component';
import { DFSectionMultiComponent } from './impl/df.section.multi';
import { DFTabsSectionMultiComponent } from './impl/df.tabs.section.multi';
import { DFSectionSingleComponent } from './impl/df.section.single';
import { DFStandardFormComponent } from './impl/df.standard.form.component';
import { DFMenuDropDownComponent } from './impl/df.menu.dropdown';
import { DFStoreFunctions } from './construct/services/store/df.store.functions';
import { DFTableListComponent } from './impl/df.table.list.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { HttpService } from 'io-ng-util/lib/common/http.service';
import { NgModule } from '@angular/core';
import { PrimeComponents } from './prime.components';
import { RouterModule } from '@angular/router';
import { TinyEditorComponent } from './construct/components/df.tinymce.component';
import { Store } from '@ngrx/store';
import { Object2Array } from './construct/services/df.object.array.pipe';
var DynamicFormModule = /** @class */ (function () {
    function DynamicFormModule() {
    }
    DynamicFormModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        DFBpImgComponent,
                        DFButtonsComponent,
                        DFComponent,
                        DFFieldsetGroupComponent,
                        DFGroupBodyComponent,
                        DFGroupComponent,
                        DFLinksComponent,
                        DFListComponent,
                        DFMenuDropDownComponent,
                        DFQuestionComponent,
                        DFReadComponent,
                        DFSectionMultiComponent,
                        DFSectionSingleComponent,
                        DFStandardFormComponent,
                        DFTableListComponent,
                        DFTabsSectionMultiComponent,
                        Object2Array,
                        TinyEditorComponent,
                    ],
                    exports: PrimeComponents.concat([
                        CommonModule,
                        DFBpImgComponent,
                        DFButtonsComponent,
                        DFComponent,
                        DFFieldsetGroupComponent,
                        DFGroupBodyComponent,
                        DFGroupComponent,
                        DFLinksComponent,
                        DFListComponent,
                        DFMenuDropDownComponent,
                        DFQuestionComponent,
                        DFReadComponent,
                        DFSectionMultiComponent,
                        DFSectionSingleComponent,
                        DFStandardFormComponent,
                        DFTableListComponent,
                        DFTabsSectionMultiComponent,
                        FormsModule,
                        ReactiveFormsModule,
                        RouterModule,
                        TinyEditorComponent,
                    ]),
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule
                    ].concat(PrimeComponents, [
                        RouterModule,
                    ]),
                    providers: [
                        DFCommonService,
                        HttpService,
                        DFFilterService,
                        DFStoreFunctions,
                        DFFormService,
                        Store,
                    ],
                },] },
    ];
    /** @nocollapse */
    DynamicFormModule.ctorParameters = function () { return []; };
    return DynamicFormModule;
}());
export { DynamicFormModule };
