'use strict';
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { ChangeDetectionStrategy, ChangeDetectorRef, Component, Input } from '@angular/core';
import { tmpl } from './templates/df.section.single.pug';
import { DFStoreFunctions } from '../construct/services/store/df.store.functions';
import { Store } from '@ngrx/store';
import 'rxjs/add/operator/debounceTime';
import { default as each } from 'lodash-es/each';
var DFSectionSingleComponent = /** @class */ (function () {
    function DFSectionSingleComponent(cd, DSF, store) {
        var _this = this;
        this.awaitData = function (rules, store) {
            var storeName = _this.DSF.r_getStore(store);
            _this.AStore = _this.store
                .select(function (s) { return s.coverage.states[storeName]; })
                .debounceTime(100)
                .subscribe(function (data) {
                if (data !== undefined) {
                    _this.handleRules(data, rules);
                }
            });
            return;
        };
        this.handleRules = function (data, rules) {
            each(rules, function (rule) {
                switch (rule.rule) {
                    case 'hide-when':
                        var hidden_1 = false;
                        each(rule.conditions, function (condition) {
                            switch (condition.operator) {
                                case 'equals':
                                    hidden_1 = data.values[condition.left] === condition.right
                                        ? true
                                        : false;
                                    break;
                                default:
                                    return;
                            }
                        });
                        _this.fieldset.fieldset.hidden = hidden_1;
                        _this.check();
                        break;
                    default:
                        return;
                }
            });
        };
        this.getValues = function (formValues) {
            var values = _this.fieldset.values;
            if (values) {
                if (formValues) {
                    return __assign({}, formValues, { values: values });
                }
                else {
                    return values;
                }
            }
            return formValues;
        };
        this.check = function () {
            _this.cd.markForCheck();
        };
        this.cd = cd;
        this.DSF = DSF;
        this.store = store;
    }
    DFSectionSingleComponent.prototype.ngOnInit = function () {
        if (this.fieldset && this.fieldset.fieldset && this.fieldset.fieldset.rules) {
            this.awaitData(this.fieldset.fieldset.rules, this.fieldset.fieldset.store);
        }
    };
    DFSectionSingleComponent.prototype.ngOnDestroy = function () {
        if (this.AStore) {
            this.AStore.unsubscribe();
        }
        console.info('$df.section.single.component (ngOnDestroy) => destroying subscription ');
    };
    DFSectionSingleComponent.decorators = [
        { type: Component, args: [{
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    selector: 'df-section-single',
                    template: tmpl,
                },] },
    ];
    /** @nocollapse */
    DFSectionSingleComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, },
        { type: DFStoreFunctions, },
        { type: Store, },
    ]; };
    DFSectionSingleComponent.propDecorators = {
        "fieldset": [{ type: Input },],
    };
    return DFSectionSingleComponent;
}());
export { DFSectionSingleComponent };
